config/routes.rb
Rails.application.routes.draw do
  get 'transactions/top_up'
  post 'transactions/do_top_up'
  get 'transactions/peer_transfer'
  post 'transactions/do_peer_transfer'
  get 'transactions/team_share'
  post 'transactions/do_team_share'
  get 'transactions/stock_invest'
  post 'transactions/do_stock_invest'
  get 'transactions/withdraw_team_share'
  post 'transactions/do_withdraw_team_share'
  get 'transactions/withdraw_stock_invest'
  post 'transactions/do_withdraw_stock_invest'
  get "wallet/show"

  resources :wallet
  resources :stocks
  resources :teams
  resources :users
  root 'users#index'
end

app/models/user.rb
class User < ApplicationRecord
    include Walletable

    has_one :wallet, :as => :owner
    has_many :memberships
    has_many :portfolios, :as => :investor
    has_many :teams, :through => :memberships
    has_many :stocks, :through => :portfolios

    validates :name, presence: true

    def getTeamShareBalance(team)
        transactions = Transaction.where("wallet_id = ? AND ref_wallet_id = ?", team.wallet.id, self.wallet.id)

        balance = 0
        transactions.each do |t|
            balance += t.type == 'Credit' ? t.amount : (t.amount * -1)
        end

        return balance
    end

    def getStockShareBalance(stock)
        transactions = Transaction.where("wallet_id = ? AND ref_wallet_id = ?", stock.wallet.id, self.wallet.id)

        balance = 0
        transactions.each do |t|
            balance += t.type == 'Credit' ? t.amount : (t.amount * -1)
        end

        return balance
    end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: %i[ show edit update destroy ]

  # GET /users or /users.json
  def index
    @users = User.all.order(:name)
  end

  # GET /users/1 or /users/1.json
  def show
  end

  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
  end

  # POST /users or /users.json
  def create
    @user = User.new(user_params)

    respond_to do |format|
      if @user.save
        format.html { redirect_to @user, notice: "User was successfully created." }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /users/1 or /users/1.json
  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to @user, notice: "User was successfully updated." }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1 or /users/1.json
  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to users_url, notice: "User was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_user
      @user = User.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def user_params
      params.require(:user).permit(:name)
    end
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/users/_form.html.erb
<%= form_with(model: user) do |form| %>
  <%= render 'shared/form_error', model: user %>

  <div class="mb-3">
    <%= form.label :name, nil, class: "form-label" %>
    <%= form.text_field :name, class: "form-control" %>
  </div>

  <div class="actions">
    <%= form.submit class: "btn btn-primary" %>
  </div>
<% end %>

app/views/users/edit.html.erb
<h1>Editing User</h1>

<%= render 'form', user: @user %>

<br />

<div>
    <%= link_to users_path, class: "btn btn-secondary" do %>
        <i class="fas fa-arrow-circle-left"></i>
        Back
    <% end %>
    <%= link_to @user, class: "btn btn-success" do %>
        <i class="fas fa-search"></i>
        Show
    <% end %>
</div>

app/views/users/index.html.erb
<div class="d-flex justify-content-between align-items-center">
    <div class="p-2">
      <h1>Users</h1>
    </div>
    <div class="p-2">
      <%= link_to new_user_path, class: "btn btn-primary" do %>
        <i class="fas fa-plus-circle"></i>
        New User
      <% end %>
    </div>
</div>

<table class="table table-striped">
  <thead>
    <tr>
      <th colspan="2"></th>
    </tr>
  </thead>

  <tbody>
    <% @users.each do |user| %>
      <tr>
        <td><%= user.name %></td>
        <td>
          <div>
            <%= link_to user, class: "btn btn-success" do %>
              <i class="fas fa-search"></i>
              Show
            <% end %>
            <%= link_to edit_user_path(user), class: "btn btn-warning" do %>
              <i class="fas fa-edit"></i>
              Edit
            <% end %>
            <%= link_to user, method: :delete, data: { confirm: 'Are you sure?' }, class: "btn btn-danger" do %>
              <i class="fas fa-trash"></i>
              Delete
            <% end %>
          </div>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/users/new.html.erb
<h1>New User</h1>

<%= render 'form', user: @user %>

<br />

<div>
    <%= link_to users_path, class: "btn btn-secondary" do %>
        <i class="fas fa-arrow-circle-left"></i>
        Back
    <% end %>
</div>

app/views/users/show.html.erb
<table class="table table-striped">
    <thead>
        <tr>
            <th colspan="2">
                <h2><%= @user.name %></h2>
            </th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>Balance</td>
            <td>
                <div class="d-flex justify-content-between align-items-center">
                    <div class="p-2 fw-bold">
                        Rp <%= format_amount @user.wallet.get_balance %>
                    </div>
                    <div class="p-2">
                        <%= link_to(wallet_path(@user.wallet), class: 'btn btn-primary') do %>
                            <i class="fas fa-wallet nav-icon"></i>
                            Open Wallet
                        <% end %>
                    </div>
                </div>
            </td>
        </tr>
        <tr>
            <td>Teams</td>
            <td>
                <ul class="list-group list-group-flush">
                    <% @user.teams.order(:name).each do |t| %>
                    <li class="list-group-item d-flex justify-content-between align-items-start bg-transparent">
                        <div class="ms-2 me-auto">
                            <div class="fw-bold"><%= t.name %></div>
                            (Rp <%= format_amount @user.getTeamShareBalance(t) %>)
                        </div>
                    </li>
                    <% end %>
                </ul>
            </td>
        </tr>
        <tr>
            <td>Portfolios</td>
            <td>
                <ul class="list-group list-group-flush">
                    <% @user.stocks.order(:name).each do |s| %>
                    <li class="list-group-item d-flex justify-content-between align-items-start bg-transparent">
                        <div class="ms-2 me-auto">
                            <div class="fw-bold"><%= s.name %></div>
                            (Rp <%= format_amount @user.getStockShareBalance(s) %>)
                        </div>
                    </li>
                    <% end %>
                </ul>
            </td>
        </tr>
    </tbody>
</table>

<div>
    <%= link_to users_path, class: "btn btn-secondary" do %>
        <i class="fas fa-arrow-circle-left"></i>
        Back
    <% end %>
    <%= link_to edit_user_path(@user), class: "btn btn-warning" do %>
        <i class="fas fa-edit"></i>
        Edit
    <% end %>
</div>